﻿using DataSharing.Province.SendTask;
using DataSharing.Province.SendTask.ProvinceOther;
using DataSharing.Share.Dtos.Statistics;
using Hotline.Share.Dtos;
using Microsoft.AspNetCore.Http;
using SqlSugar;
using XF.Domain.Dependency;

namespace DataSharing.Repository
{
    public class WaitSendTaskRepository : BaseRepository<DsWaitSendTaskProvinceOther>, IWaitSendTaskRepository, IScopeDependency
    {
        public WaitSendTaskRepository(ISugarUnitOfWork<DataSharingDbContext> uow) : base(uow)
        {

        }

        public ISugarQueryable<T> UnionAll<T>(params ISugarQueryable<T>[] queryables) where T : class
        {
            return Db.UnionAll(queryables);
        }

        /// <summary>
        /// 汇聚数据查询
        /// </summary>
        /// <param name="sql"></param>
        /// <returns></returns>
        public List<DataAggregationSituationDto> GetDataAggregationSituation(string sql)
        {
            return Db.Ado.SqlQuery<DataAggregationSituationDto>(sql);

        }

        /// <summary>
        /// 根据sql查询分页数据
        /// </summary>
        /// <param name="sql"></param>
        /// <returns></returns>
        public async Task<PagedDto<object>> GetDataBySql(string sql, int pageIndex, int pageSize, CancellationToken cancellationToken = default)
        {
            RefAsync<int> total = 0;

            var items = await Db.SqlQueryable<object>(sql).ToPageListAsync(pageIndex, pageSize, total, cancellationToken);

            return new PagedDto<object>(total, items);


        }
    }
}
